import sys

instructions = { # these must match execute.py
    "loadi":  0,
    "load":   1,
    "store":  2,
    "less":   3,
    "add":    4,
    "sub":    5,
    "mul":    6,
    "div":    7,
    "mod":    8,
    "jump":   9,
    "jumpf": 10,
    "out":   11,
    "halt":  12,
}

def lpad(s, n): return     (" " * (n - len(s))) + s
def rpad(s, n): return s + (" " * (n - len(s)))

def intify(x): return int(x) if (x[0].isdigit()) else ord(x[0])

source = [line.strip() for line in sys.stdin.readlines()]

labels = {}

for asmpass in range(2):
    program = []
    for line in source:
        if 0 == len(line): continue
        if line[0].isdigit():
            label = int(line)
            value = len(program)
            labels[label] = value
            sys.stderr.write("\t\t\t\t# " + lpad(str(value), 5) + " =\tlabel " + str(label) + "\n")
            continue
        insn = [x.strip() for x in line.split("\t")]
        if len(insn) > 1:
            insn = [insn[0]] + list(map(intify, [x.strip() for x in insn[1].split(",")]))
        op = insn[0]
        if op == "jump":
            if asmpass > 0: insn[1]= labels[insn[1]]
        if op == "jumpf":
            if asmpass > 0: insn[2]= labels[insn[2]]
        insn[0] = instructions[insn[0]]
        addr = str(len(program))
        asm  = str(insn)
        if asmpass > 0:
            sys.stderr.write("\t" + rpad(asm, 24) + "# " + lpad(addr, 5) + "\t" + line + "\n")
        program += insn

print program
