nextLabel = 0

def newLabel():
    global nextLabel
    label = nextLabel
    nextLabel = nextLabel + 1
    return label

def emitLabel(label):
    print(str(label))

def emit  (op      ):   print("\t" + op                               )
def emitRI(op, r, i):   print("\t" + op + "\t" + str(r) + "," + str(i))
def emitRM(op, r, m):   print("\t" + op + "\t" + str(r) + "," +     m )
def emitRR(op, r, s):   print("\t" + op + "\t" + str(r) + "," + str(s))
def emitRL(op, r, l):   print("\t" + op + "\t" + str(r) + "," + str(l))
def emitR (op,    r):   print("\t" + op + "\t" +                str(r))
def emitM (op,    m):   print("\t" + op + "\t" +                    m )
def emitL (op,    l):   print("\t" + op + "\t" +                str(l))

def compile(t, i):
    op = t[0]
    if   op == "int":     emitRI("loadi", i, t[1])
    elif op == "id":      emitRM("load",  i, t[1])
    elif op == "mod":     emitRR("mod",   compile(t[1], i), compile(t[2], i+1))
    elif op == "div":     emitRR("div",   compile(t[1], i), compile(t[2], i+1))
    elif op == "mul":     emitRR("mul",   compile(t[1], i), compile(t[2], i+1))
    elif op == "sub":     emitRR("sub",   compile(t[1], i), compile(t[2], i+1))
    elif op == "add":     emitRR("add",   compile(t[1], i), compile(t[2], i+1))
    elif op == "less":    emitRR("less",  compile(t[1], i), compile(t[2], i+1))
    elif op == "assign":  emitRM("store", compile(t[2], i), t[1][1])
    elif op == "print":
        compile(t[1], i)
        emitR("out",  i)
    elif op == "while":
        test, rest = newLabel(), newLabel()
        emitLabel(test)
        compile(t[1], i)
        emitRL("jumpf", i, rest)
        compile(t[2], i)
        emitL("jump", test)
        emitLabel(rest)
    else:
        print("I do not grok: " + str(t))
        exit()
    return i


def find_input():
    try:
        return raw_input
    except:
        return input

raw_input = find_input()


while True:
    try:
        ast = eval(raw_input())
        compile(ast, 0)
    except:
        emit("halt")
        break
