nextLabel = 0

def newLabel():
    global nextLabel
    label = nextLabel
    nextLabel = nextLabel + 1
    return label

def emit  (op      ):   print("\t" + op)
def emitX (op, x   ):   emit (op + "\t" + x)
def emitXX(op, x, y):   emitX(op, x + ", " + y)

def reg(r): return "%r"+str(8+r)
def imm(i): return "$"+str(i)
def mem(m): return str(8*ord(m))+"(%rbp)"
def lbl(l): return "L"+str(l)

def emitR (op, r   ):   emitX (op, reg(r)        )
def emitRR(op, r, s):   emitXX(op, reg(r), reg(s))
def emitRX(op, r, x):   emitXX(op, reg(r), x     )
def emitXR(op, x, r):   emitXX(op, x,      reg(r))
def emitIR(op, i, r):   emitXX(op, imm(i), reg(r))
def emitRM(op, r, m):   emitXX(op, reg(r), mem(m))
def emitMR(op, m, r):   emitXX(op, mem(m), reg(r))
def emitL (op, l   ):   emitX (op, lbl(l))

def emitLabel(label):   print(lbl(label)+":")

def compile(t, i):
    op = t[0]
    if   op == "int":     emitIR("movabs", t[1], i)
    elif op == "id":      emitMR("mov",    t[1], i)
    elif op == "assign":  emitRM("mov",    compile(t[2], i),   t[1][1])
    elif op == "add":     emitRR("add",    compile(t[2], i+1), compile(t[1], i))
    elif op == "sub":     emitRR("sub",    compile(t[2], i+1), compile(t[1], i))
    elif op == "mul":     emitRR("imul",   compile(t[2], i+1), compile(t[1], i))
    elif op == "div":
        compile(t[1],  i)
        compile(t[2],  i+1)
        emitRX("mov",  i, "%rax")
	emit  ("cqto")
	emitR ("idiv", i+1)
        emitXR("mov", "%rax", i)
    elif op == "mod":
        compile(t[1],  i)
        compile(t[2],  i+1)
        emitRX("mov",  i, "%rax")
	emit  ("cqto")
	emitR ("idiv", i+1)
        emitXR("mov",  "%rdx", i)
    elif op == "less":
	emitRR("cmp",    compile(t[2], i+1), compile(t[1], i))
	emitX ("setl",   "%al")
	emitXX("movzbl", "%al", "%eax")
	emitXR("movsl",  "%eax", i)
    elif op == "print":
        compile(t[1], i)
        emitXX("movabs", "$format", "%rdi")
        emitRX("mov",    i, "%rsi")
        emitXX("xor",    "%rax", "%rax")
        emitX ("call",   "_printf")
    elif op == "while":
        test, rest = newLabel(), newLabel()
        emitLabel(test)
        compile(t[1],   i)
        emitRR ("test", i, i)
        emitL  ("je",   rest)
        compile(t[2],   i)
        emitL("ja",     test)
        emitLabel(rest)
    else:
        print("I do not grok: " + str(t))
        exit()
    return i


def find_input():
    try:
        return raw_input
    except:
        return input

raw_input = find_input()

# prologue

print("	.data\n\
vars:	.space	8*256\n\
format:	.asciz	\"%i\\n\"\n\
	.text\n\
	.global	_main\n\
_main:	push	%rbp\n\
	mov	%rsp, %rbp\n\
	push	%r12\n\
	push	%r13\n\
	push	%r14\n\
	push	%r15\n\
	push	%rbx\n\
	sub	$24, %rsp\n\
	lea	vars(%rip), %rbp\n\
")

# program

while True:
    try:
        ast = eval(raw_input())
        compile(ast, 0)
    except EOFError:
        break

# epilog

print("	xor	%rax, %rax\n\
	add	$24, %rsp\n\
	pop	%rbx\n\
	pop	%r15\n\
	pop	%r14\n\
	pop	%r13\n\
	pop	%r12\n\
	pop	%rbp\n\
	ret\
")
