import sys

def find_input():
    try:    return raw_input
    except: return input

raw_input = find_input()

program = eval(raw_input())

reg = [0] * 32
mem = [0] * 256
pc  = 0

def loadi(): # loadi reg imm
    global program, reg, mem, pc
    r = program[pc+1]
    i = program[pc+2]
    reg[r] = i
    pc += 3

def load(): # load reg memaddr
    global program, reg, mem, pc
    r = program[pc+1]
    m = program[pc+2]
    reg[r] = mem[m]
    pc += 3

def store(): # store reg memaddr
    global program, reg, mem, pc
    r = program[pc+1]
    m = program[pc+2]
    mem[m] = reg[r]
    pc += 3

def less(): # less reg reg
    global program, reg, mem, pc
    r1 = program[pc+1]
    r2 = program[pc+2]
    reg[r1] = 1 if reg[r1] < reg[r2] else 0
    pc += 3

def add(): # add reg reg
    global program, reg, mem, pc
    r1 = program[pc+1]
    r2 = program[pc+2]
    reg[r1] += reg[r2]
    pc += 3

def sub(): # sub reg reg
    global program, reg, mem, pc
    r1 = program[pc+1]
    r2 = program[pc+2]
    reg[r1] -= reg[r2]
    pc += 3

def mul(): # mul reg reg
    global program, reg, mem, pc
    r1 = program[pc+1]
    r2 = program[pc+2]
    reg[r1] *= reg[r2]
    pc += 3

def div(): # div reg reg
    global program, reg, mem, pc
    r1 = program[pc+1]
    r2 = program[pc+2]
    reg[r1] /= reg[r2]
    pc += 3

def mod(): # mod reg reg
    global program, reg, mem, pc
    r1 = program[pc+1]
    r2 = program[pc+2]
    reg[r1] %= reg[r2]
    pc += 3

def jump(): # jump progaddr
    global program, reg, mem, pc
    pc = program[pc+1]

def jumpf(): # jumpf reg progaddr
    global program, reg, mem, pc
    r = program[pc+1]
    pc = program[pc+2] if reg[r] == 0 else pc+3

def out(): # out reg
    global program, reg, mem, pc
    r = program[pc+1]
    print(reg[r])
    pc += 2

def out(): # out reg
    global program, reg, mem, pc
    r = program[pc+1]
    print(reg[r])
    pc += 2

def halt(): # halt
    global program, reg, mem, pc
    print("halt")
    sys.exit(0)

instructions = [ # these must match assemble.py
    loadi,
    load,
    store,
    less,
    add,
    sub,
    mul,
    div,
    mod,
    jump,
    jumpf,
    out,
    halt
]

while True:
    instructions[program[pc]]()
